<?php
// Set PDF header
header("Content-type: application/pdf");
// Include Mage
require __DIR__ . '/../app/Mage.php';
// Include SFAPIclient
require_once('SFAPIclient.php');
// Use all storeviews
Mage::app()->setCurrentStore(Mage_Core_Model_App::ADMIN_STORE_ID);
// Order ID
$order = Mage::getModel('sales/order')->load($_GET['id']);
// Billing address
$billingAddress = $order->getBillingAddress();
$shippingAddress = $order->getShippingAddress();
$payment_method = $order->getPayment()->getMethod();
$shipping_method = $order->getShippingMethod();

$pm = '';
$sm = '';

if($payment_method == 'paypal_standard') {
	$pm = 'paypal';
} else if($payment_method == 'banktransfer') {
	$pm = 'transfer';
}

if($shipping_method == 'smashingmagazine_mycarrier_kurier') {
	$sm = 'courier';
} else if ($shipping_method == 'freeshipping_freeshipping') {
	$sm = 'personal';
}

$api = new SFAPIclient('[Email]', '[API Klíč]');

$order_tax = 0.00;


//add invoice item, this can be called multiple times
//if you are not a VAT registered, use tax = 0
$items = $order->getItemsCollection();
foreach ($items as $item) {
    $product = $item->getProduct();
	$tax = (float) $item->getTaxPercent();
	if($tax != 0) {
		$order_tax = $tax;
	}
    $api->addItem(array(
        'name' => $item->getName(),
        'description' => $item->getSku(),
        'quantity' => intval($item->getQtyOrdered()),
        'unit' => 'ks',
        'unit_price' => number_format($item->getPrice(), 2, '.',''),
        'tax' => number_format($item->getTaxPercent(),2,'.',''),
    ));
}


$sa = (float) $order->getShippingAmount();
if($sa != 0.00) {
	$api->addItem(array(
        'name' => $order->getShippingDescription(),
        'description' => 'Doprava',
        'quantity' => intval(1),
        'unit' => 'ks',
        'unit_price' => number_format($sa, 2, '.',''),
        'tax' => number_format($order_tax,2,'.',''),));
}

// Dobírka
$cod = (float) $order->getCodFee(); 
if($cod != 0.00) {
	$api->addItem(array(
        'name' => 'Dobírka',
        'description' => 'Dobírka',
        'quantity' => intval(1),
        'unit' => 'ks',
        'unit_price' => number_format($cod, 2, '.',''),
        'tax' => number_format($order_tax,2,'.',''),));
}

//setup client data
$api->setClient(array(
    'name' => '' . $order->getCustomerFirstname() . ' ' . $order->getCustomerLastname(),
    'ico' => '',
    'dic' => '',
    'ic_dph' => '',
    'email' => '' . $order->getCustomerEmail(),
    'address' => '' . $billingAddress->getStreet(1),
    'city' => $billingAddress->getCity(),
    'zip' => '' . $billingAddress->getPostcode(),
    'phone' => '' . $billingAddress->getTelephone(),
	'country_id' => '' .  (($billingAddress->getCountryId() == 'SK')?191:57),
	'delivery_address' => $shippingAddress->getStreet(1),
    'delivery_city' => $shippingAddress->getCity(),
	'delivery_country_id' => (($shippingAddress->getCountryId() == 'SK')?191:57),
	'delivery_name' => $shippingAddress->getFirstname() . ' ' . $shippingAddress->getLastname(),
	'delivery_zip' => $shippingAddress->getPostcode(),
));

//setup invoice data
$api->setInvoice(array(
    'name' => '' . ((intval($order->getStoreId()) == 1) ? 'Proforma Invoice ' . $order->getIncrementId() : 'Zálohová faktúra ' . $order->getIncrementId()),
    'already_paid' => false, //has the invoices been already paid?
    'created' => '' . date("Y-m-d", strtotime($order->getCreatedAt())), //date of issue
	'type' => 'proforma',
	'payment_type' => $pm,
	'delivery_type' => $sm,
));

//save invoice
$response = $api->save();

// DB connection
$db = Mage::getSingleton('core/resource')->getConnection('core_write');

// response object contains data about created invoices, or error messages respectively
if ($response->error === 0) {
    //complete information about created invoice
    $invoice_id = $response->data->Invoice->id;
    $invoice_token = $response->data->Invoice->token;
    $db->query("UPDATE sales_flat_order SET proinvoice_id='" . $invoice_id . "',proinvoice_token='" . $invoice_token . "' WHERE increment_id = '" . $order->getIncrementId() . "'");
    echo $api->getPdf(intval($invoice_id), $invoice_token, ((intval($order->getStoreId()) == 1) ? 'eng' : 'slo'));
} else {
    echo $api->getPdf(intval($order->getProinvoiceId()), $order->getProinvoiceToken(), ((intval($order->getStoreId()) == 1) ? 'eng' : 'slo'));
}